// K12.4 ؂̃tN^WFl[^
import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*;  

class TreeGenerator extends JPanel{
    InputP ip;
    Tree area;

    TreeGenerator(){
       setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
       area = new Tree();
       ip = new InputP(this);
       add(area);
       add(ip);            
    }

    public static void main(String args[]){
       JFrame f  = new JFrame("Tree Fractal Generator");
       TreeGenerator tg = new TreeGenerator();
       f.getContentPane().add(tg, BorderLayout.CENTER);
       f.pack();
       f.setVisible(true);
    }
}  

class InputP extends Panel implements ActionListener { 
   TreeGenerator top;
   JButton goB;            //`{^
   JComboBox scaleC, angleC, nC;  // I

   InputP(TreeGenerator t){
      top = t;
      setBackground(Color.white);
      scaleC = new JComboBox();  // }̔䗦̐ݒ 
      for (double d=0.8; d>=0.5; d=d-0.05) { 
            scaleC.addItem((d+0.001+" ").substring(0,4)); 
      } 
      angleC = new JComboBox();  // }̍Lpx̐ݒ 
      for (int i=30; i<=90; i+=10) {    
         angleC.addItem(""+i); 
      } 
      nC = new JComboBox();      // JԂ񐔂̐ݒ 
      for (int i=1; i<=20; i++) {  
         nC.addItem(""+i); 
      } 
      goB=new JButton("`"); // `{^ 
      //CxgXi[̐ݒ
      scaleC.addActionListener(this);
      angleC.addActionListener(this);
      nC.addActionListener(this);
      goB.addActionListener(this); 
      //zu
      add(new Label("}̔䗦"));  
      add(scaleC);
      add(new Label("}̊px")); 
      add(angleC);
      add(new Label(""));
      add(nC);
      add(goB);
      } 
   public void actionPerformed(ActionEvent e) { 
      if(e.getSource() == goB) {  top.area.repaint();  } 
      Object obj=e.getSource(); 
      if(obj == scaleC) {
         top.area.scale =
             Double.valueOf((String)scaleC.getSelectedItem()).doubleValue();
       } else if (obj == angleC) {
         top.area.angle =
             Integer.valueOf((String)angleC.getSelectedItem()).intValue();
       } else if (obj == nC) { 
         top.area.n = Integer.valueOf((String)nC.getSelectedItem()).intValue();
       }

   }
}

class Tree extends JPanel{
    double scale;      // }̔䗦 
    int angle;          // }̍Lpx 
    int n;               // JԂ 
    double stand,len;    // ŏ̎}̕A}̒ 
    int w,h; 
    final double RAD=Math.PI/180.0;  // WAɕϊ邽߂̒l

    Tree() {   // \bh 
       setBorder(BorderFactory.createMatteBorder(3,3,3,3,Color.green));
       setMinimumSize(new Dimension(300, 300));  //ŏTCYݒ
       setPreferredSize(new Dimension(300, 300));//]ރTCYݒ
       scale=0.8;      // }̔䗦 
       angle=30;       // }̍Lpx 
       n=1;            // JԂ 
       stand=90;
       len=100;    // ŏ̎}̒ 
    }   

    public void paintComponent(Graphics g) { 
       w=getSize().width;               // 
       h=getSize().height;              // 
       g.setColor(Color.white);  // wiF 
       g.fillRect(0,0,w,h);            // wi 
       g.setColor(new Color(100, 153, 0));  // F̐ݒ 
       drawTree(g,n,w/2,0,len,stand);        // ؂` 
    }
    
    //؂ċAIɕ`
    void drawTree(Graphics g, int nn, double x1, double y1, 
                                                double len,double stand){ 
       double x2,y2; 
       x2=len*Math.cos(RAD*stand)+x1;            //}xW
       y2=len*Math.sin(RAD*stand)+y1;            //}yW
       g.drawLine((int)x1,(int)(h-y1),(int)x2,(int)(h-y2)); 

       if(nn>1){
       drawTree(g,nn-1,x2,y2,len*scale,stand-angle); //̉E̎} 
       drawTree(g,nn-1,x2,y2,len*scale,stand+angle); //̍̎} 
       }
     } 
}



