// Xgf[^CCt@C֕ۑ
// VK{^Ɠ͈̃f[^Xg̍Ōɒǉ(f[^łǉ)
// 폜{^ƑIꂽڂ폜

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.io.*;

class ListEdit3 extends JFrame implements ActionListener{ 
  ListPanel listP;       //JListupl
  EntryPanel entryP;     //͈ƃ{^̃pl
  JMenuBar mbar;         //j[o[
  JMenu menu;
  JMenuItem saveM, exitM;

  String name;           //͈ɓ閼Op
  String weight;         //͈ɓ̏dp
  String height;         //͈ɓgp


  ListEdit3(String title){
     super(title);

     mbar = new JMenuBar();
     setJMenuBar(mbar);
     menu = new JMenu("t@C");
     saveM = createMenuItem("ۑ", menu);
     exitM = createMenuItem("I", menu);
     mbar.add(menu);

     Container c = getContentPane();
     listP = new ListPanel();
     entryP = new EntryPanel();
     c.add(listP, BorderLayout.CENTER);
     c.add(entryP, BorderLayout.EAST);
  }     

  JMenuItem createMenuItem(String str, JMenu parent){
     JMenuItem m;
     m = new JMenuItem(str);
     m.addActionListener(this);
     parent.add(m);
     return m;
  }
 
  public void actionPerformed(ActionEvent e){
     Object obj = e.getSource();
     if(obj == saveM){
        try{
          listP.dataWrite();
        }catch(IOException error) { System.out.println("File write error");}
     }
     else if(obj == exitM){
          System.exit(0);
     }
   }

  public static void main(String[] args) {
     ListEdit3 f = new ListEdit3("Edit List Data");        
     f.pack();
     f.setVisible(true);
  }


  //JListupl
  class ListPanel extends JPanel implements ListSelectionListener {
    JList list;
    DefaultListModel listModel;
    int select = -1; //IꂽڃCfbNX,N-1
    String entry; //Iꂽړe

    ListPanel(){
       try {
	 dataRead();
       } catch(IOException e) {}

       list = new JList(listModel);
       list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
       list.addListSelectionListener(this);
       add(new JScrollPane(list)); //listꂽJScrollPaneJPanelɒu
    }

    void dataRead() throws IOException{ //t@Cǂ
       BufferedReader din = new BufferedReader(new FileReader("list.data"));
       listModel = new DefaultListModel();
       while ((entry=din.readLine()) != null) { //1sǂ
	  listModel.addElement(entry);  //Xgڂɒǉ
       }
       din.close();
     }    

    void dataWrite() throws IOException{
       BufferedWriter dout = new BufferedWriter(new FileWriter("list.data"));
       int n = listModel.getSize();
       for(int i=0; i<n; i++){
	  entry =(String)listModel.get(i);
	  dout.write(entry);
	  dout.newLine();
       }
       dout.close();
     }    

     public void valueChanged(ListSelectionEvent e) {
	select = list.getSelectedIndex();
	entry = (String)(listModel.get(select));

	if(select != -1) {
	   int pb;                        //󔒂̈ʒu
	   pb = entry.indexOf(' ');  
	   name = entry.substring(0, pb);  //O̕؂o
	   String sub = entry.substring(pb+1); 
	   pb = sub.indexOf(' ');
	   weight = sub.substring(0,pb);  //̏d؂o
	   height = sub.substring(pb+1);  //g؂o

	   entryP.inP.inN.setText(name);
	   entryP.inP.inW.setText(weight);
	   entryP.inP.inH.setText(height);
	 }
     }
  }

  class EntryPanel extends JPanel{
    InPanel inP;
    ButtonPanel buttonP;

    EntryPanel(){
       Border border = BorderFactory.createEmptyBorder(10,5,10,5);
       setBorder(border);

       setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
       inP = new InPanel();
       buttonP = new ButtonPanel();
       add(inP);
       add(buttonP);
    }

     class InPanel extends JPanel implements ActionListener{ 
       JTextField inN;
       JTextField inW;
       JTextField inH;

       InPanel(){
	 setLayout(new GridLayout(3,2));  //CAEgݒ  
	 inN = new JTextField(10);  //̓tB[h𐶐
	 inW = new JTextField(10);  
	 inH = new JTextField(10);  
	 inN.addActionListener(this);
	 inW.addActionListener(this);
	 inH.addActionListener(this);
	 add(new JLabel("O"));      //plɕizu
	 add(inN);
	 add(new JLabel("̏d(Kg)"));
	 add(inW);
	 add(new JLabel("g(cm)"));      
	 add(inH);                     
       }
       //̓tB[hreturnL[ꂽAs郁\bh
       public void actionPerformed(ActionEvent e){  
	  Object obj = e.getSource();
	  if(obj == inN) inW.requestFocus();
	  else if(obj == inW) inH.requestFocus();
	  else if(obj == inH) inN.requestFocus();
       }
     }

     class ButtonPanel extends JPanel implements ActionListener{ 
       JButton changeB, newB, delB;

       ButtonPanel(){
	  changeB = createButton("ύX");
	  newB = createButton("VK");
	  delB = createButton("폜");
       }

       JButton createButton(String str){
	  JButton b = new JButton(str);
	  b.addActionListener(this);
	  add(b);
	  return b;
       }

       public void actionPerformed(ActionEvent e){
	  Object obj = e.getSource();
	  if(obj == changeB && listP.select != -1){  //ύX{^
	      if(!getData()) return;
	      listP.listModel.set(listP.select, 
                                   name + " " + weight + " " + height);
	   }
	  else if(obj == newB){  //VK{^
	      if(!getData()) return;
	      listP.listModel.addElement(name + " " + weight + " " + height);
              listP.list.setSelectedIndex(listP.listModel.getSize()-1);
	   }
	  else if(obj == delB && listP.select != -1){  //폜{^
	      listP.listModel.remove(listP.select);
              listP.select = -1;
	      inP.inN.setText("");
	      inP.inW.setText("");
	      inP.inH.setText("");
	  }
      }
     
      boolean getData(){ // ͈̃f[^𓾂Dl̃`FbN
         float f = 0.0F;
	 name = inP.inN.getText();
         //Õ`FbN(󔒂Xy[XŎn܂ꍇ)
         if(name.length()==0 || name.startsWith(" ")){
	         inP.inN.requestFocus(); return false; }
         //̏dCg̃`FbN(lɕϊłȂ͂ꂽꍇ)
	 try{   
	    weight = inP.inW.getText();
	    f = Float.parseFloat(weight);
	    } catch (NumberFormatException error){ 
	         inP.inW.requestFocus(); return false; }
	 try{
	    height = inP.inH.getText();
	    f = Float.parseFloat(height);
	 } catch (NumberFormatException error){
		inP.inH.requestFocus(); return false; }
         return true;
      } 
    }
  }
}
